<?php

////携帯でGoogleMapの画像をプリントするクラス
//class GoogleMobileMapView {
//	private $geturl = "http://maps.google.com/mapprint?tstyp=4";
//	private $query = "";
//	private $image_format = "1";
//	private $type = array("1"=>"gif","2"=>"png","3"=>"jpeg");
//
//	//画像を取得するためのURLをセットするメソッド
//	public function setUrl($latitude,$longitude,$settings,$points = null) {
//		//中心の位置がない場合はfalseを返す
//		if( $latitude == "" || $longitude == ""){
//			return false;
//		}
//
//		//画像を取得するためのパラメータをセットしていく
//		$this->query = $this->geturl . "&c=$longitude,$latitude";
//		if(!isset($settings["w"])) $settings["w"] = 200;
//		if(!isset($settings["h"])) $settings["h"] = 200;
//		if(!isset($settings["z"])) $settings["z"] = 0;
//		$this->query .= "&r={$settings["w"]},{$settings["h"]}";
//		$this->query .= "&z={$settings["z"]}";
//
//		//出力形式をセット（デフォルトはGIF
//		if(isset($settings["image_format"])) $this->image_format = $settings["image_format"];
//		$this->query .= "&image_format=" . $this->image_format;
//
//		//複数のポイントを表示するのにも対応させる
//		if(!is_array($points)) return true;
//		foreach( $points as $point ){
//			if(!isset($point["latitude"]) || !isset($point["longitude"])) continue;
//			if(!isset($point["iconid"]) ) $point["iconid"] = 15;
//			$this->query .= "&l={$point["longitude"]},{$point["latitude"]},{$point["iconid"]}";
//		}
//		return true;
//	}
//
//	//画像を出力するメソッド
//	public function viewPicture() {
//		$pic_type = $this->image_format;
//		header("Content-type: image/" . $this->type[$pic_type]);
//		if ($this->query != ""){
//			readfile($this->query);
//		}
//	}
//}

//-----------------------------------------------
// □　機種判別
//-----------------------------------------------
function GetAgentType(){
	$strAgentType = $_SERVER["HTTP_USER_AGENT"];

	//echo "Agent Type : $strAgentType<br>";

	$strIsDoCoMo  = substr($strAgentType,0,6);
	$strIsKDDI    = substr($strAgentType,0,4);
	$strIsJPHONE  = substr($strAgentType,0,7);
	$strIsPC      = substr($strAgentType,0,7);
	$strIsHDML    = substr($strAgentType,0,10);

	if( $strIsDoCoMo == "DoCoMo" )
		$strType  = AGENT_DOCOMO;

	if( $strIsKDDI == "KDDI" || strpos($strAgentType,"UP.Browser")>1 )
		$strType  = AGENT_KDDI;

	if( $strIsHDML == "UP.Browser" )
		$strType  = AGENT_HDML;

	if( $strIsJPHONE == "J-PHONE" )
		$strType  = AGENT_JPHONE;

	if( strpos("  ". $strAgentType,"Mozilla")>1)
		$strType  = AGENT_PC;

	if( strpos("  ". $strAgentType,"Opera")>1)
		$strType  = AGENT_PC;

	return $strType;
}

//-----------------------------------------------
// □　和暦変換用の関数
//-----------------------------------------------
function to_wareki($y, $m, $d)
{
	//年月日を文字列として結合
	$ymd = sprintf("%02d%02d%02d", $y, $m, $d);
	if ($ymd <= "19120729") {
		$gg = "明治";
		$yy = $y - 1867;
	} elseif ($ymd >= "19120730" && $ymd <= "19261224") {
		$gg = "大正";
		$yy = $y - 1911;
	} elseif ($ymd >= "19261225" && $ymd <= "19890107") {
		$gg = "昭和";
		$yy = $y - 1925;
	} elseif ($ymd >= "19890108") {
		$gg = "平成";
		$yy = $y - 1988;
	}
	$wareki = "{$gg}{$yy}年{$m}月{$d}日";
	return $wareki;
}

//-----------------------------------------------
// □　西暦から和暦に変換
//-----------------------------------------------
function seireki_wareki($strseireki,$strwareki){
	$strwareki="";
	if ($strseireki>"1988"){
		$intseireki=(integer)$strseireki-1988;
		$strwareki="平成" .$intseireki;
	}
	elseif ($strseireki>"1925"){
		$intseireki=(integer)$strseireki-1925;
		$strwareki="昭和" .$intseireki;

	}
	elseif ($strseireki>"1911"){
		$intseireki=(integer)$strseireki-1911;
		$strwareki="大正" .$intseireki;
	}

	elseif ($strseireki>"1867"){
		$intseireki=(integer)$strseireki-1867;
		$strwareki="明治" .$intseireki;
	}
}

//-----------------------------------------------
// □　和暦から西暦に変換
//-----------------------------------------------
function wareki_seireki($strwarekinengo,$strwarekinen,$strseireki){
	$strseireki="";
	switch($strwarekinengo){
		case "1"://明治
			$strseireki=1867+(integer)$strwarekinen;
			break;
		case "2"://大正
			$strseireki=1911+(integer)$strwarekinen;
			break;
		case "3"://昭和
			$strseireki=1925+(integer)$strwarekinen;
			break;
		case "4"://平成
			$strseireki=1988+(integer)$strwarekinen;
			break;
	}
}

function rmdir_recurse($path)
{
	$path= @rtrim($path, '/').'/';
	$handle = @opendir($path);
	for (;false !== ($file = @readdir($handle));)
		if($file != "." and $file != ".." ) {
			$fullpath= $path.$file;
			if( @is_dir($fullpath) ) {
				rmdir_recurse($fullpath);
				@rmdir($fullpath);
			}
			else
				@unlink($fullpath);
		}
		
	@rmdir($path);
	@closedir($handle);
}

function randomstring($len) {
	srand(date("s"));
	while($i<$len) {
		$str.=chr((rand()%26)+97);
		$i++;
	}
  
	$str=$str.substr(uniqid (""),0,22);
	return $str;
}

function pageing_link_build($pg_name) {
	global $pageing_contents;
	global $total_count;
	global $display_detail_limit;
	global $page;
	
	// << 次の１０件を表示  1　2　3　4　5　6　7　8　9　10  次の１０件を表示 >> 
		
	$pageing_contents 		=  "";
	$total_page			= ceil($total_count / $display_detail_limit);
	
	$min_page			= floor(($page - 1) / 10) * 10 + 1;
	$max_page			= $min_page + 9;
	if ($max_page > $total_page) {
		$max_page 		= $total_page;
	}
		
	if ($page > 10) {
		$previous_page	= $min_page - 10;
		$pageing_contents 	.=  "<a href='$pg_name?page=$previous_page'>&lt;&lt; 前の10件を表示</a>　　";
	}
	
	if ($total_page > 1) {
		for ($i = $min_page; $i <= $max_page; $i++) {
			if ($i == $page) {
				$pageing_contents 	.=  $i . "　";
			}
			else {
				$pageing_contents 	.=  "<a href='$pg_name?page=$i'>$i</a>　";
			}			
		}
	}	

	if ($max_page < $total_page) {
		if ($max_page + 10 < $total_page) {
			$next_page_block	= 10;
		}
		else {
			$next_page_block	= $total_page - $max_page;
		}		
		
		$next_page		= $max_page + 1;
		$pageing_contents 	.=  "　<a href='$pg_name?page=$next_page'>次の{$next_page_block}件を表示 &gt;&gt;</a>";
	}		
	
	if ($total_page < 2) {
		$pageing_contents	= "";
	}
}

function imagesize_check($file_name, $max_width, $max_height) {
	list($img_width, $img_height) 		= getimagesize("../upimages/" . $file_name);
	if ($max_width < $img_width || $max_height < $img_height) {
		if ($img_width > $img_height) {
			$img_height		= $img_height * ($max_width / $img_width);
			$img_width		= $max_width;
		}
		else {
			$img_width		= $img_width * ($max_height / $img_height);
			$img_height		= $max_height;
		}
	}
	return $img_width . "_" . $img_height;
}

function auth_check($program_name, $service_code) {
	global $array_auth_matrix;

	if ($program_name != ""
		&& $service_code != ""
		&& strlen($service_code) == 2
		&& is_numeric($service_code) == true) {
		$service_type	= 4 - floor($service_code / 10);
		$auth_string 	= $array_auth_matrix[$program_name];
		$auth_code 	= substr($auth_string, $service_type, 1);
	}
	else {
		$auth_code 	="0";
	}
	return $auth_code;
}

function group_code_name($group_code) {
	global $array_group;
	return $array_group[$group_code];
}

function group_code_bind($group_code) {
	global $array_group;
	$option_string = "";
	foreach($array_group AS $key => $value){
		if ($key == $group_code) {
			$option_string .= "<OPTION VALUE='" . $key . "' selected>" . $value . "</OPTION>\n";
		}
		else {
			$option_string .= "<OPTION VALUE='" . $key . "'>" . $value . "</OPTION>\n";
		}
	}
	return $option_string;
}

function bind_railway_name($code) {
	global $cn;
	$railway_name = "";
	$sql = "SELECT railway_name ";
	$sql .= "FROM station ";
	$sql .= "WHERE id = '$code' ";
	$result	= mysql_query($sql);
	while ($item = mysql_fetch_assoc($result)) {
		$railway_name		= $item['railway_name'];
	}
	return $railway_name;
}

function bind_station_name($code) {
	global $cn;
	$station_name = "";
	$sql = "SELECT station_name ";
	$sql .= "FROM station ";
	$sql .= "WHERE id = '$code' ";
	$result	= mysql_query($sql);
	while ($item = mysql_fetch_assoc($result)) {
		$station_name		= $item['station_name'];
	}
	return $station_name;
}

function group_name($group_id) {
	global $cn;
	$sql = "SELECT name ";
	$sql .= "FROM chp_group ";
	$sql .= "WHERE id = '$group_id' ";
	$result	= mysql_query($sql);
	$rows 	= mysql_num_rows($result);
	while ($item = mysql_fetch_assoc($result)) {
		$group_name		= $item['name'];
	}
	return $group_name;
}

function group_bind($group_id) {
	global $cn;
	$group_id_string	= "";
	$sql = "SELECT id, name ";
	$sql .= "FROM chp_group ";
	$sql .= "ORDER BY id ";
	$result	= mysql_query($sql);
	$rows 	= mysql_num_rows($result);
	while ($item = mysql_fetch_assoc($result)) {
		$db_id		= $item['id'];
		$db_name 	= $item['name'];
		if ($group_id != "" && $db_id == $group_id) {
			$group_id_string .= "<OPTION VALUE='" . $db_id . "' selected>" . $db_name . "</OPTION>\n";
		}
		else {
			$group_id_string .= "<OPTION VALUE='" . $db_id . "'>" . $db_name . "</OPTION>\n";
		}
	}
	return $group_id_string;
}

function work_area_name($area_code) {
	global $cn;
	$db_area_name = "";
	$sql = "SELECT area_name ";
	$sql .= "FROM area_master ";
	$sql .= "WHERE area_code = '$area_code' ";
	$result	= mysql_query($sql);
	$rows 	= mysql_num_rows($result);
	while ($item = mysql_fetch_assoc($result)) {
		$db_area_name		= $item['area_name'];
	}
	return $db_area_name;
}

function work_area_bind($area_code) {
	global $cn;
	$area_cd_string = "";
	$sql = "SELECT area_code, area_name ";
	$sql .= "FROM area_master ";
	$sql .= "ORDER BY show_seq, area_code ";
	$result	= mysql_query($sql);
	$rows 	= mysql_num_rows($result);
	while ($item = mysql_fetch_assoc($result)) {
		$db_area_code			= $item['area_code'];
		$db_area_name 		= $item['area_name'];
		if ($area_code != "" && $db_area_code == $area_code) {
			$area_cd_string .= "<OPTION VALUE='" . $db_area_code . "' selected>" . $db_area_name . "</OPTION>\n";
		}
		else {
			$area_cd_string .= "<OPTION VALUE='" . $db_area_code . "'>" . $db_area_name . "</OPTION>\n";
		}
	}
	return $area_cd_string;
}

function work_place_bind($area, $place) {
	global $cn;
	$result_string = "";
	$sql = "SELECT a.area_code, a.area_name ";
	$sql .= "FROM area_master a ";
	$sql .= "WHERE a.area_code > '" .$area  . "00' ";
	$sql .= "AND a.area_code < '" .$area  . "99' ";
	$sql .= "ORDER BY a.show_seq ";
	$rs 	= mysql_query($sql);	
	$rows = mysql_num_rows($rs);
	while ($item = mysql_fetch_assoc($rs)) {
		$db_area_code			= $item['area_code'];
		$db_area_name 		= $item['area_name'];
		if ($place != "" && $db_area_code == $place) {
			$result_string .= "<OPTION VALUE='" . $db_area_code . "' selected>" . $db_area_name . "</OPTION>\n";
		}
		else {
			$result_string .= "<OPTION VALUE='" . $db_area_code . "'>" . $db_area_name . "</OPTION>\n";
		}
	}
	return $result_string;
}

function city_name($city_code) {
	global $cn;
	$db_city_name = "";
	$sql = "SELECT city_name ";
	$sql .= "FROM cities ";
	$sql .= "WHERE city_code = '$city_code' ";
	$sql .= "ORDER BY city_code ";
	$result	= mysql_query($sql);
	$rows 	= mysql_num_rows($result);
	while ($item = mysql_fetch_assoc($result)) {
		$db_city_name 		= $item['city_name'];
	}
	//$db_city_name		= addslashes_sjis($db_city_name);
	return $db_city_name;
}

function city_bind($prefecture_code, $city_code) {
	global $cn;
	$city_cd_string = "";
	$sql = "SELECT city_code, city_name ";
	$sql .= "FROM cities ";
	$sql .= "WHERE prefecture_code = '$prefecture_code' ";
	$sql .= "ORDER BY city_code ";
	$result	= mysql_query($sql);
	$rows 	= mysql_num_rows($result);
	while ($item = mysql_fetch_assoc($result)) {
		$db_city_code		= $item['city_code'];
		$db_city_name 		= $item['city_name'];
		//$db_city_name		= addslashes_ext3($db_city_name);
		if ($city_code != "" && $db_city_code == $city_code) {
			$city_cd_string .= "<OPTION VALUE='" . $db_city_code . "' selected>" . $db_city_name . "</OPTION>\n";
		}
		else {
			$city_cd_string .= "<OPTION VALUE='" . $db_city_code . "'>" . $db_city_name . "</OPTION>\n";
		}
	}
	return $city_cd_string;
}

function age_group_bind($code) {
	global $array_age;
	$result_string = "";
	foreach($array_age AS $key => $value){
		if ($key == $code) {
			$result_string .= "<OPTION VALUE='" . $key . "' selected>" . $value . "</OPTION>\n";
		}
		else {
			$result_string .= "<OPTION VALUE='" . $key . "'>" . $value . "</OPTION>\n";
		}
	}
	return $result_string;
}

function area_code_bind($code) {
	global $array_area;
	$result_string = "";
	foreach($array_area AS $key => $value){
		if ($key == $code) {
			$result_string .= "<OPTION VALUE='" . $key . "' selected>" . $value . "</OPTION>\n";
		}
		else {
			$result_string .= "<OPTION VALUE='" . $key . "'>" . $value . "</OPTION>\n";
		}
	}
	return $result_string;
}

function subarea_code_bind($area_code, $subarea_code) {
	$sql = "SELECT a.area_code, a.area_name ";
	$sql .= "FROM area_master a ";
	$sql .= "WHERE a.area_code > '" .$area_code  . "00' ";
	$sql .= "AND a.area_code < '" .$area_code  . "99' ";
	$sql .= "ORDER BY a.show_seq ";
	$rs 	= mysql_query($sql);	
	$idx = 0;
	$result_string = "<OPTION VALUE=''>選択してください</OPTION>\n";
	while ($item = mysql_fetch_array($rs)) {
		$area_code    		= $item['area_code'];
		$area_name         	= $item['area_name'];
		if ($area_code == $subarea_code) {
			$result_string .= "<OPTION VALUE='" . $area_code . "' selected>" . $area_name . "</OPTION>\n";
		}
		else {
			$result_string .= "<OPTION VALUE='" . $area_code . "'>" . $area_name . "</OPTION>\n";
		}
	}
	return $result_string;
}

function subarea_name($code) {
	$result_string 		= "";
	$sql = "SELECT area_name ";
	$sql .= "FROM area_master ";
	$sql .= "WHERE area_code = '$code' ";
	$result	= mysql_query($sql);
	while ($item = mysql_fetch_assoc($result)) {
		$result_string 		= $item['area_name'];
	}
	return $result_string;
}

function create_radio_list($array_list, $item_name, $code) {
	$option_string = "";
	foreach($array_list AS $key => $value){
		if ($code == $key) {		
			$option_string .= "<input type=\"radio\" name=\"{$item_name}\" value=\"{$key}\" checked/> {$value} ";
		}
		else {
			$option_string .= "<input type=\"radio\" name=\"{$item_name}\" value=\"{$key}\" /> {$value} ";
		}
	}
	return $option_string;
}

function create_radio_list3($array_list, $item_name, $code) {
	$option_string = "";
	$cnter = 1;
	foreach($array_list AS $key => $value){
		if ($code == $key) {		
			$option_string .= "<input type=\"radio\" name=\"{$item_name}\" value=\"{$key}\" checked/> {$value} ";
		}
		else {
			$option_string .= "<input type=\"radio\" name=\"{$item_name}\" value=\"{$key}\" /> {$value} ";
		}
		if ($cnter == 2) 
			$option_string .= "<br>";
		$cnter++;
	}
	return $option_string;
}

function create_checkbox_list($array_list, $item_name, $code_string) {
	$option_string = "";
	foreach($array_list AS $key => $value){
		if (strpos($code_string, "_" . $key . "_") > 0) {		
			$option_string .= "<input type=\"checkbox\" name=\"{$item_name}[]\" value=\"{$key}\" checked/> {$value} ";
		}
		else {
			$option_string .= "<input type=\"checkbox\" name=\"{$item_name}[]\" value=\"{$key}\" /> {$value} ";
		}
	}
	return $option_string;
}

function create_checkbox_list2($array_list, $item_name, $code_string) {
	$option_string = "";
	foreach($array_list AS $key => $value){
		if (strpos("_" . $code_string, $key ."") > 0) {		
			$option_string .= "<input type=\"checkbox\" name=\"{$item_name}[]\" value=\"{$key}\" checked/> {$value} <br>\n";
		}
		else {
			$option_string .= "<input type=\"checkbox\" name=\"{$item_name}[]\" value=\"{$key}\" /> {$value} <br>\n";
		}
	}
	return $option_string;
}

function create_selected_list($array_list, $code_string) {
	$result_string = "";
	foreach($array_list AS $key => $value){
		if (strpos($code_string, "_" . $key . "_") > 0) {		
			$result_string .= "$value  ";
		}
	}
	return $result_string;
}

function create_option_range_list($array_list, $code) {
	$option_string = "";
	foreach($array_list AS $key => $value){
		if ($key == $code) {
			$option_string .= "<OPTION VALUE='" . $key . "' selected>" . $value . "</OPTION>\n";
		}
		else {
			$option_string .= "<OPTION VALUE='" . $key . "'>" . $value . "</OPTION>\n";
		}
	}
	return $option_string;
}

function sex_bind($code) {
	global $array_sex;
	$sex_string 	= "";
	$cnter		= 0;
	foreach($array_sex AS $key => $value){
		$cnter++;
		if ($key == $code) {
			$sex_string .= "<OPTION VALUE='" . $key . "' selected>" . $value . "性</OPTION>\n";
		}
		else {
			$sex_string .= "<OPTION VALUE='" . $key . "'>" . $value . "性</OPTION>\n";
		}
		if ($cnter > 1) break;
	}
	return $sex_string;
}

function font_size_bind($code) {
	global $array_font_size;
	$font_size_string = create_option_list($array_font_size, $code);
	return $font_size_string;
}

function prefecture_bind($code) {
	global $array_prefecture;
	$prefecture_string = create_option_list($array_prefecture, $code);
	return $prefecture_string;
}
function prefecture_name($code) {
	global $array_prefecture;
	return $array_prefecture[$code];
}

function period_bind($code) {
	global $array_period;
	$period_string = create_option_list($array_period, $code);
	return $period_string;
}
function period_name($code) {
	global $array_period;
	return $array_period[$code];
}

function create_option_list($array_list, $code) {
	$option_string = "";
	foreach($array_list AS $key => $value){
		if ($key == $code) {
			$option_string .= "<OPTION VALUE='" . $key . "' selected>" . $value . "</OPTION>\n";
		}
		else {
			$option_string .= "<OPTION VALUE='" . $key . "'>" . $value . "</OPTION>\n";
		}
	}
	return $option_string;
}

function do_post_request_https($url, $data, $optional_headers = null) {
	$context_options = array (
	        'http' => array (
	            'method' => 'POST',
	            'header'=> "Content-type: application/x-www-form-urlencoded\r\n"
	                . "Content-Length: " . strlen($data) . "\r\n",
	            'content' => $data
	            )
	        );


	$context = stream_context_create($context_options);
	echo "context:" . $context . "\n";
	$fp = fopen($url, 'r', false, $context);


	if (!$fp) {
		echo "Problem with $url, $php_errormsg";
	}
	else {
		echo "url:" . $url . "\n";
		echo "fp:" . $fp . "\n";
	}
	$response = stream_get_contents($fp);
	if ($response === false) {
		echo "Problem reading data from $url, $php_errormsg";
	}
	echo "response:" . $response . "\n";

	return $response;
}

function do_post_request($url, $data, $optional_headers = null) {
	$params = array('http' => array('method' => 'POST','content' => $data));
	if ($optional_headers !== null) {
		$params['http']['header'] = $optional_headers;
	}
	$ctx = stream_context_create($params);
	$fp = @fopen($url, 'rb', false, $ctx);
	if (!$fp) {
		echo "Problem with $url, $php_errormsg";
	}
	$response = stream_get_contents($fp);
	if ($response === false) {
		echo "Problem reading data from $url, $php_errormsg";
	}
	return $response;
}

function countup_access($user_id) {
	global $cn;
	$check_flag		= "";
	$sql = "SELECT *, DATEDIFF(CURDATE(), base_date) AS date_diff ";
	$sql .= "FROM access ";
	$sql .= "WHERE userid = '$user_id' ";
	$sql .= "ORDER BY base_date DESC ";
	$sql .= "LIMIT 0, 1";
	$result	= mysql_query($sql);
	$rows 	= mysql_num_rows($result);
	while ($item = mysql_fetch_assoc($result)) {
		$check_flag			= "*";
		$base_date			= $item['base_date'];
		$date_diff				= $item['date_diff'];
		$db_count_today 		= $item['count_today'];
		$db_count_yesterday 	= $item['count_yesterday'];
		$db_count_tilltoday 		= $item['count_tilltoday'];
	}

	if ($check_flag == "") {
		$count_today 			= 1;
		$count_yesterday		= 0;
		$count_tilltoday 		= 1;

		$sql = "INSERT INTO access VALUES(";
		$sql .= "sysdate(), ";
		$sql .= "'$user_id', ";
		$sql .= "'1', ";
		$sql .= "'0', ";
		$sql .= "'1') ";
		$result	= mysql_query($sql);
	}
	elseif ($date_diff > 0) {
		$count_today 			= 1;
		if ($date_diff == 1) {
			$count_yesterday 		= $db_count_today;
		}
		else {
			$count_yesterday 		= 0;
		}
		$count_tilltoday 		= $db_count_tilltoday + 1;

		$sql = "INSERT INTO access VALUES(";
		$sql .= "CURDATE(), ";
		$sql .= "'$user_id', ";
		$sql .= "'$count_today', ";
		$sql .= "'$count_yesterday', ";
		$sql .= "'$count_tilltoday') ";
		$result	= mysql_query($sql);

	//	$sql = "DELETE FROM access WHERE base_date < CURDATE()";
	//	$result	= mysql_query($sql);
	}
	else {
		$count_today 			= $db_count_today + 1;
		$count_yesterday		= $db_count_yesterday;
		$count_tilltoday 		= $db_count_tilltoday + 1;

		$sql = "UPDATE access SET ";
		$sql .= "count_today = '$count_today', ";
		$sql .= "count_tilltoday = '$count_tilltoday' ";
		$sql .= "WHERE userid = '$user_id' ";
		$sql .= "AND base_date = CURDATE() ";

		$result	= mysql_query($sql);

	//	$sql = "DELETE FROM access WHERE base_date < CURDATE()";
	//	$result	= mysql_query($sql);
	}

	return "$count_today/$count_yesterday/$count_tilltoday";
}

function sendmail($email,$subject,$message) {
	global $email_general;

	// 文字変換
	$subject = '=?ISO-2022-JP?B?' . base64_encode(JcodeConvert($subject, 0, 2)) . '?=';
	$message = JcodeConvert($message, 2, 3);
	mail($email,$subject,$message,"From: $email_general") ;


//	// メール送信
//	$mail = new PHPMailer();
//
//	$mail->IsSMTP();
//	$mail->Host     		= "ziewave.com";
//	$mail->Port     		= "587";
//	$mail->SMTPAuth 		= true;
//	$mail->Username 		= "lee_euikyu";
//	$mail->Password 		= "whilelek";
//	$mail->CharSet 		= "iso-2022-jp";
//	$mail->Encoding		= "7bit";
//	$mail->WordWrap 		= 500;
//	$mail->IsHTML(false);
//
//	$email_general		= "lek@oha.jp";
//
//	$mail->From     	= $email_general;
//	$mail->FromName 	= "phoenixcare";
//	$mail->AddAddress($customer_email);
//	$mail->AddReplyTo($email_general,"test");
//
//	$mail->Subject  =  "[phoenixcare] パスワード再発行";
//	$mail->Body     =  "パスワード情報です\n$passwd";
//
//	if(!$mail->Send()) {
//	//   echo "Message was not sent <p>";
//	//   echo "Mailer Error: " . $mail->ErrorInfo;
//	//   exit;
//	}
}

function randomkeys($length) {
	$pattern = "abcdefghijklmnopqrstuvwxyz";
	for($i=0;$i<$length;$i++) {
		if(isset($key))
			$key .= $pattern{rand(0,25)};
		else
			$key = $pattern{rand(0,25)};
	}
	return $key;
}

function array_removal_byindex($idx, &$arr) {
	$array_remval = $arr;

	$array_temp  = array_slice($array_remval, 0, $idx );
	$array_temp2 = array_slice($array_remval, $idx + 1, count($array_remval)-1 );
	$array_remval = array_merge($array_temp, $array_temp2);

	return $array_remval;
}

function array_removal_byvalue($val, &$arr) {
	$array_remval = $arr;
	for($x=0;$x<count($array_remval);$x++) {
		$i=array_search($val,$array_remval);
		if (is_numeric($i)) {
			$array_temp  = array_slice($array_remval, 0, $i );
			$array_temp2 = array_slice($array_remval, $i+1, count($array_remval)-1 );
			$array_remval = array_merge($array_temp, $array_temp2);
		}
	}
	return $array_remval;
}

function begin() {
	@mysql_query("BEGIN");
}
function commit() {
	@mysql_query("COMMIT");
}
function rollback() {
	@mysql_query("ROLLBACK");
}

/* thumbnail process */
function thumbnail_sub($src_img) {
	$max_width		= 120;
	$max_height		= 70;

	$width = imagesx($src_img); // get original source image width
	$height = imagesy($src_img); // and height

	// create small thumbnail	
	if ($width > $max_width || $height > $max_height) {
		if (($width / $height) > ($max_width / $max_height)) {
			$dest_width = $max_width;
			$dest_height = floor($height *  $max_width / $width);
		}
		else {
			$dest_width =  floor($width * $max_height / $height);
			$dest_height = $max_height;
		}
	}	
	else {
			$dest_width =  $width;
			$dest_height = $height;
	}

//	$dest_img = imagecreatetruecolor($dest_width, $dest_height);
	$dest_img = imagecreate($dest_width, $dest_height);

//	$result = imagecopyresampled(
//		$dest_img, $src_img,
//		0, 0, 0, 0,
//		$dest_width, $dest_height,
//		$width, $height); // resize the image

	imagecopyresized(
		$dest_img, $src_img,
		0, 0, 0, 0,
		$dest_width, $dest_height,
		$width, $height); // resize the image

	ob_start(); // Start capturing stdout.
	imageJPEG($dest_img); // As though output to browser.
	$binaryThumbnail = ob_get_contents(); // the raw jpeg image data.
	ob_end_clean(); // Dump the stdout so it does not screw other output.
	
	return $binaryThumbnail;
}

function thumbnail_sub2($src_img) {
	$max_width		= 360;
	$max_height		= 270;

	$width = imagesx($src_img); // get original source image width
	$height = imagesy($src_img); // and height

	// create small thumbnail	
	if ($width > $max_width || $height > $max_height) {
		if (($width / $height) > ($max_width / $max_height)) {
			$dest_width = $max_width;
			$dest_height = floor($height *  $max_width / $width);
		}
		else {
			$dest_width =  floor($width * $max_height / $height);
			$dest_height = $max_height;
		}
	}	
	else {
			$dest_width =  $width;
			$dest_height = $height;
	}

//	$dest_img = imagecreatetruecolor($dest_width, $dest_height);
	$dest_img = imagecreate($dest_width, $dest_height);

//	$result = imagecopyresampled(
//		$dest_img, $src_img,
//		0, 0, 0, 0,
//		$dest_width, $dest_height,
//		$width, $height); // resize the image

	imagecopyresized(
		$dest_img, $src_img,
		0, 0, 0, 0,
		$dest_width, $dest_height,
		$width, $height); // resize the image

	ob_start(); // Start capturing stdout.
	imageJPEG($dest_img); // As though output to browser.
	$binaryThumbnail = ob_get_contents(); // the raw jpeg image data.
	ob_end_clean(); // Dump the stdout so it does not screw other output.
	
	return $binaryThumbnail;
}

function thumbnail($src_img, $ext) {
	$width = imagesx($src_img);
	$height = imagesy($src_img);

	if ($width > 120) {
		$dest_width =  120;
		$dest_height = ceil($height * (120 / $width));
	}
	elseif ($height > 70) {
		$dest_height =  70;
		$dest_width = ceil($width * (70 / $height));
	}
	else {
		$dest_width =  $width;
		$dest_height = $height;
	}

	// GD 2.0 or later用
	$dest_img = imagecreatetruecolor($dest_width, $dest_height);
	$result = imagecopyresampled(
		$dest_img, $src_img,
		0, 0, 0, 0,
		$dest_width, $dest_height,
		$width, $height);

//	// GD 2.0前用
//	$dest_img = imagecreate($dest_width, $dest_height);
//	$result = imagecopyresized(
//		$dest_img, $src_img,
//		0, 0, 0, 0,
//		$dest_width, $dest_height,
//		$width, $height);

	ob_start();
	if ($ext == "jpg") {
		imageJPEG($dest_img);
	}
	elseif ($ext == "gif") {
		imageGIF($dest_img);
	}
	else {
		imagePNG($dest_img);
	}
	$binaryThumbnail = ob_get_contents();
	ob_end_clean();
	return $binaryThumbnail;
}

function xml2array ($name, $xml, $Echar='.', $Achar='/', $discardempty=true) {
	static $Result, $A, $E, $Discard;

	//if ((strlen ($xml) < 256) && is_file ($xml))
	//$xml = file_get_contents ($xml);

	if ($name == '') {
		$Result = array ();
		$A = $Achar;
		$E = $Echar;
		$Discard = $discardempty;
	}

	$ReElements = '/<(\w+)\s*([^\/>]*)\s*(?:\/>|>(.*)<\/\s*\\1\s*>)/s';
	$ReAttributes = '/(\w+)=(?:"|\')([^"\']*)(:?"|\')/';
	preg_match_all ($ReElements, $xml, $elements);
	foreach ($elements[1] as $ie => $xx) {
		if ( $attributes = trim($elements[2][$ie])) {
			preg_match_all ($ReAttributes, $attributes, $att);
			foreach ($att[1] as $ia => $xx)
			$Result[$name.$E.$elements[1][$ie].$A.$att[1][$ia]] = $att[2][$ia];
		}

		if (preg_match ($ReElements, $elements[3][$ie]))
			xml2array ($name ? $name.$E.$elements[1][$ie] : $elements[1][$ie], $elements[3][$ie]);
		else if (!$Discard || $elements[3][$ie])
			$Result[$name.$E.$elements[1][$ie]] = $elements[3][$ie];
	}
	return $Result;
}

// Best one
function valid_email($ma) {
//	// check an email address is possibly valid
//	//if (ereg('^[a-zA-Z0-9_.-]+@[a-zA-Z0-9-]+.[a-zA-Z0-9-]*', $ma))
//	if (ereg("^[_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-])*@([a-zA-Z0-9-]+\.)+([_a-zA-Z]{2,3})$"), $ma) {
//		return true;
//	}
//	else {
//		return false;
//	}
}

// Validates that address is RFC822 compliant:
// email address validation function
function is_valid_email_address($email) {
	$qtext = '[^\\x0d\\x22\\x5c\\x80-\\xff]';
	$dtext = '[^\\x0d\\x5b-\\x5d\\x80-\\xff]';
	$atom = '[^\\x00-\\x20\\x22\\x28\\x29\\x2c\\x2e\\x3a-\\x3c'. '\\x3e\\x40\\x5b-\\x5d\\x7f-\\xff]+';
	$quoted_pair = '\\x5c\\x00-\\x7f';
	$domain_literal = "\\x5b($dtext|$quoted_pair)*\\x5d";
	$quoted_string = "\\x22($qtext|$quoted_pair)*\\x22";
	$domain_ref = $atom;
	$sub_domain = "($domain_ref|$domain_literal)";
	$word = "($atom|$quoted_string)";
	$domain = "$sub_domain(\\x2e$sub_domain)*";
	$local_part = "$word(\\x2e$word)*";
	$addr_spec = "$local_part\\x40$domain";
	return preg_match("!^$addr_spec$!", $email) ? true : false;
}



function mailcheck($ma){
$ok =
ereg("^[0-9,A-Z,a-z][0-9,a-z,A-Z,_,\.,-]+@
[0-9,A-Z,a-z][0-9,a-z,A-Z,_,\.,-]+\.
(af|al|dz|as|ad|ao|ai|aq|ag|ar|am|aw|ac|au|at|az|
bh|bd|bb|by|bj|bm|bt|bo|ba|bw|br|io|bn|bg|bf|bi|kh|
cm|ca|cv|cf|td|gg|je|cl|cn|cx|cc|co|km|cg|cd|ck|cr|
ci|hr|cu|cy|cz|dk|dj|dm|do|tp|ec|eg|sv|gq|er|ee|et|
fk|fo|fj|fi|fr|gf|pf|tf|fx|ga|gm|ge|de|gh|gi|gd|gp|gu|
gt|gn|gw|gy|ht|hm|hn|hk|hu|is|in|id|ir|iq|ie|im|il|it|
jm|jo|kz|ke|ki|kp|kr|kw|kg|la|lv|lb|ls|lr|ly|li|lt|lu|
mo|mk|mg|mw|my|mv|ml|mt|mh|mq|mr|mu|yt|mx|fm|md|mc|mn|
ms|ma|mz|mm|na|nr|np|nl|an|nc|nz|ni|ne|ng|nu|nf|mp|no|
om|pk|pw|pa|pg|py|pe|ph|pn|pl|pt|pr|qa|re|ro|ru|rw|kn|
lc|vc|ws|sm|st|sa|sn|sc|sl|sg|sk|si|sb|so|za|gs|es|lk|
sh|pm|sd|sr|sj|sz|se|ch|sy|tw|tj|tz|th|bs|ky|tg|tk|to|
tt|tn|tr|tm|tc|tv|ug|ua|ae|uk|us|um|uy|uz|vu|va|ve|vn|
vg|vi|wf|eh|ye|yu|zm|zw|
com|net|org|gov|edu|int|mil|biz|info|name|pro|jp)
$",$ma);
return $ok;
}

function valid_mail($email) // 正しい書式のメールアドレスの場合は、1 を返す
{
if(preg_match('/^(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff])|"[^\\\\\x80-\xff\n\015"]*(?:\\\\[^\x80-\xff][^\\\\\x80-\xff\n\015"]*)*")(?:\.(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff])|"[^\\\\\x80-\xff\n\015"]*(?:\\\\[^\x80-\xff][^\\\\\x80-\xff\n\015"]*)*"))*@(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff])|\[(?:[^\\\\\x80-\xff\n\015\[\]]|\\\\[^\x80-\xff])*\])(?:\.(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff])|\[(?:[^\\\\\x80-\xff\n\015\[\]]|\\\\[^\x80-\xff])*\]))*$/', $email)) return 1;
}

if (!function_exists('stream_get_contents')) {
	function stream_get_contents($resource) {
		$result = '';

		if (is_resource($resource)) {
			while (!feof($resource)) {
				$result .= @fread($resource, 2048);
			}
		}

		return $result;
	}
}

function addslashes_sjis($sjis) {
	$euc=mb_convert_encoding($sjis,EUC,SJIS);
	$euc=addslashes($euc);
	$sjis=mb_convert_encoding($euc,SJIS,EUC);
	return $sjis;
}

function addslashes_ext3($sjis) {
  /*
   * 機能: 区切り文字(\xff)を入れて、ASCIIのみをaddslashesする。
   * 警告: 区切り文字が$sjisに含まれていた場合の動作は保証外。
   * 注意: ereg_replaceは\x00をサポートしていないことがあるので、
   *       \xffを使う。preg_replaceは、\x00をサポートしている。
   */

  // 文字コードの範囲
  $sjis_high = "[\x81-\x9f\xe0-\xfc]";
  $sjis_low  = "[\x40-\x7e\x80-\xfc]";
  $ank       = "[\x01-\x7f\xa0-\xdf]";

  // とりあえず、addslashesしちゃう
  $escaped = addslashes($sjis);

  // 問題が発生する文字列があるか調べる
  if (ereg("($sjis_high\\\\)\\\\", $escaped)) {
    // 問題がありそう。一文字ずつに分解する。
    $raw_char =
    $esc_char = explode("\xff",
                        ereg_replace("(${sjis_high}${sjis_low}|$ank)",
                                     "\\1\xff", $sjis));
    // 一文字ずつしらべる
    for($i=0; $i<count($raw_char); $i++)
      if (strlen($raw_char[$i]) == 1)
        $esc_char[$i] = addslashes($raw_char[$i]); // ASCIIのときはaddslashes
    // くっつける
    $escaped = implode("", $esc_char);
  }
  return $escaped;
}

    function utf8_to_unicode( $str ) {
      
        $unicode = array();        
        $values = array();
        $lookingFor = 1;
        
        for ($i = 0; $i < strlen( $str ); $i++ ) {
            $thisValue = ord( $str[ $i ] );
        if ( $thisValue < ord('A') ) {
            // exclude 0-9
            if ($thisValue >= ord('0') && $thisValue <= ord('9')) {
                 // number
                 $unicode[] = chr($thisValue);
            }
            else {
                 $unicode[] = '%'.dechex($thisValue);
            }
        } else {
              if ( $thisValue < 128) 
            $unicode[] = $str[ $i ];
              else {
                    if ( count( $values ) == 0 ) $lookingFor = ( $thisValue < 224 ) ? 2 : 3;                
                    $values[] = $thisValue;                
                    if ( count( $values ) == $lookingFor ) {
                        $number = ( $lookingFor == 3 ) ?
                            ( ( $values[0] % 16 ) * 4096 ) + ( ( $values[1] % 64 ) * 64 ) + ( $values[2] % 64 ):
                            ( ( $values[0] % 32 ) * 64 ) + ( $values[1] % 64 );
                $number = dechex($number);
                $unicode[] = (strlen($number)==3)?"%u0".$number:"%u".$number;
                        $values = array();
                        $lookingFor = 1;
              } // if
            } // if
        }
        } // for
        return implode("",$unicode);

    } // utf8_to_unicode 


function unicode2utf8($c)
{
    $output="";
    
    if($c < 0x80)
    {
        return chr($c);
    }
    else if($c < 0x800)
    {
        return chr( 0xc0 | ($c >> 6) ).chr( 0x80 | ($c & 0x3f) );
    }
    else if($c < 0x10000)
    {
        return chr( 0xe0 | ($c >> 12) ).chr( 0x80 | (($c >> 6) & 0x3f) ).chr( 0x80 | ($c & 0x3f) );
    }
    else if($c < 0x200000)
    {
        return chr(0xf0 | ($c >> 18)).chr(0x80 | (($c >> 12) & 0x3f)).chr(0x80 | (($c >> 6) & 0x3f)).chr(0x80 | ($c & 0x3f));
    }
    return false;
}


function socketmail($from, $toArray, $subject, $message) {
        $fromTitle = substr($from, strpos($from, '"'), strrpos($from, '"')-strpos($from, '"')+1);
        $fromAddr = substr($from, strpos($from, '<'), strrpos($from, '>')-strpos($from, '<')+1);
        if (strlen($fromAddr) == 1) $fromAddr = substr($from, strrpos($from, '"')+1, strlen($from));
        if (strlen($fromTitle) == 1) $fromAddr = $from;
        $connect = fsockopen ("10.200.30.3", 25, $errno, $errstr, 30)
                or die("Could not talk to the sendmail server!");
        $rcv = fgets($connect, 1024);
        //foreach($toArray as $to) {
        $to = $toArray;
                $toTitle = substr($to, strpos($to, '"'), strrpos($to, '"')-strpos($to, '"')+1);
                $toAddr = substr($to, strpos($to, '<'), strrpos($to, '>')-strpos($to, '<')+1);
                if (strlen($toAddr) == 1) $toAddr = substr($to, strrpos($to, '"')+1, strlen($to));
                if (strlen($toTitle) == 1) $toAddr = $to;
                fputs ($connect, "MAIL FROM:$fromAddr"."\r\n");
                $rcv = fgets ($connect, 1024);
                fputs ($connect, "RCPT TO:$toAddr\r\n");
                $rcv = fgets ($connect, 1024);
                fputs ($connect, "DATA\r\n");
                $rcv = fgets ($connect, 1024);
                fputs ($connect, "Subject: $subject" . "\r\n" );
                fputs ($connect, "From: $fromAddr" . "\r\n" );
                fputs ($connect, "To: $toAddr" . "\r\n" );
                fputs ($connect, "\r\n" );
                fputs ($connect, "$message " . "\r\n" );
                fputs ($connect, ".\r\n");
                $rcv = fgets ($connect, 1024);
                fputs ($connect, "RSET\r\n");
                $rcv = fgets ($connect, 1024);
        //}
        fputs ($connect, "QUIT\r\n");
        $rcv = fgets ($connect, 1024);
        fclose($connect);
}

?>